import _ from 'lodash'
import pkg from './package.json'

export default {
  mode: 'universal',

  /*
  ** Headers of the page
  */
  head: {
    title: _.startCase(pkg.name),
    meta: [
      { charset: 'utf-8' },
      { name: 'viewport', content: 'width=device-width, initial-scale=1' },
      { hid: 'description', name: 'description', content: pkg.description }
    ],
    link: [{ rel: 'icon', type: 'image/x-icon', href: '/favicon.ico' }]
  },

  /*
  ** Customize the progress-bar color
  */
  loading: { color: '#cea643' },

  /*
  ** Global CSS
  */
  css: [],
  srcDir: 'client/',
  buildDir: 'build/.nuxt',
  /*
      **Router config
      */
  router: {
    linkActiveClass: 'active',
    linkExactActiveClass: 'exact-active'
    // middleware: ['user-agent']
  },
  /*
  ** Plugins to load before mounting the App
  */
  plugins: [],

  /*
  ** Nuxt.js modules
  */
  modules: [],
  /*
  ** Axios module configuration
  */
  axios: {
    // proxyHeaders: false
    // See https://github.com/nuxt-community/axios-module#options
  },

  /*
  ** Build configuration
  */
  build: {
    /*
    ** You can extend webpack config here
    */
    extend (config, ctx) {
      // Run ESLint on save
      if (ctx.isDev && ctx.isClient) {
        config.module.rules.push({
          enforce: 'pre',
          test: /\.(js|vue)$/,
          loader: 'eslint-loader',
          exclude: /(node_modules)/
        })
      }
    }
  }
}
